;------------------------------------------------------------------
;   
;
;     :
;
;RA0 -  
;RA2 -  
;RA4 -  
;------------------------------------------------------------------
	#include	<p16f676.inc>
	errorlevel	-302
	
	__CONFIG	_CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT

MLS_CNT		EQU		0x20	; 
MLS_NUM		EQU		0x21	;  
MKS_NUM		EQU		0x22	;  

In_Nt_Count	EQU		0x23	;   
In_Nt_Num	EQU		0x24	;    
							;  ,      

Srv_Nt_Min_H	EQU		0x27	;     
Srv_Nt_Min_L	EQU		0x28	;     
Srv_Nt_Max_H	EQU		0x29	;     
Srv_Nt_Max_L	EQU		0x2A	;     

Srv_Min_H	EQU		0x2B	;     
Srv_Min_L	EQU		0x2C	;     
Srv_Max_H	EQU		0x2D	;     
Srv_Max_L	EQU		0x2E	;     

H1			EQU		0x2F	;  1-     
L1			EQU		0x30	;  1-     

H2			EQU		0x31	;  2-     
L2			EQU		0x32	;  2-     

H			EQU		0x33	;    
L			EQU		0x34	;    
CL			EQU		0x35	;       
CH			EQU		0x36	;       

CHL			EQU		0x37	;    

In_H		EQU		0x38	;     
In_L		EQU		0x39	;     

AD_H		EQU		0x3C	;     
AD_L		EQU		0x3D	;     

AD_Corr_H	EQU		0x3E	;      
AD_Corr_L	EQU		0x3F	;      

AD_Nt_H		EQU		0x40	;       
AD_Nt_L		EQU		0x41	;       

AD_Min_H	EQU		0x42	;     
AD_Min_L	EQU		0x43	;     

AD_Max_H	EQU		0x44	;     
AD_Max_L	EQU		0x45	;     

Out_Add_H	EQU		0x46	;    
Out_Add_L	EQU		0x47	;    
Out_Add_CHL	EQU		0x48	;   

Out_H		EQU		0x49	;      
Out_L		EQU		0x4A	;      
Out_CHL		EQU		0x4B

Out_Corr_H	EQU		0x4C	;      
Out_Corr_L	EQU		0x4D	;      

Add_K		EQU		0x4E	;     
Count_K		EQU		0x4F	; Add_K

Count_Srv_Nt	EQU	0x50	;      
							;  
;        
Last_Add_H		EQU	0x51	; 
Last_Add_L		EQU	0x52	; 
Last_Add_CHL	EQU	0x53	;
Right_Count		EQU	0x54	; 

			ORG		0x000
			goto	main

;  
			ORG		0x004
	;-   PORTA
			bcf		STATUS,RP0	;  0    INTCON
			btfsc	INTCON,RAIF	;     PORTA, 0-  
			call 	Int_PORTA

	;    TIMER1
			bcf		STATUS,RP0	; 0     PIR1
			btfsc	PIR1,TMR1IF	;     TIMER1
			call	Int_TIMER1	;   TIMER1

	;    AD
			bcf		STATUS,RP0	; 0     PIR1
			btfsc	PIR1,ADIF	;     AD
			call	Int_AD		;   AD

	;    TIMER0
			bcf		STATUS,RP0	; 0     INTCON
			btfsc	INTCON,T0IF	;     TIMER0
			call	Int_TMR0	;   TIMER0
			retfie

main			
;1.  

	;1.1.  	
			call	0x3FF		;  
			bsf		STATUS,RP0	;  1     OSCCAL
			movwf	OSCCAL		;   OSCCAL=W=000000 -  

	;1.3. PORTA :
			; - RA0	  
			; - RA1   0-, 1-
			; - RA2     
			; - RA3   0-   
			; - RA4	    
			; - RA5   0-   
			bcf		STATUS,RP0 	;  0     PORTA
			clrf 	PORTA 		; PORTA
			movlw 	b'00000111'	
			movwf 	CMCON		;    RA<0:2>

			bsf		STATUS,RP0	;  1     ANSEL
			movfw  	ANSEL		;   ANSEL
			andlw	b'11110001'	
			movwf	ANSEL		;  0 ANSEL<3:1>      
			movlw 	b'00001111'	; RA0:RA3  ,RA4:RA5  
			movwf 	TRISA 		
			bcf		OPTION_REG,7;    PORTA
			bsf		WPUA,2		;    RA2		

	;1.4. TIMER1
		;1.4.1.T1CON -   
			bcf		STATUS,RP0	;  0     T1CON
			bcf		T1CON,T1CKPS1	;  0 T1CKPS1 ( T1CKPS1:T1CKPS0=00   1)	
			bcf		T1CON,T1CKPS0	;  0 T1CKPS0 ( T1CKPS1:T1CKPS0=00   1)
	;1.5. TIMER0
			bsf		STATUS,RP0	;  1    OPTION_REG
			bcf		OPTION_REG,T0CS	;T0SC=0     
			bcf		OPTION_REG,PSA	;PSA=0	   TMR0
			bsf		OPTION_REG,PS2
			bsf		OPTION_REG,PS1
			bsf		OPTION_REG,PS0	;PS2:PS0=111  256

;2. 

	;2.1.  	
			bcf		STATUS,RP0	;  0     INTCON

			bsf		INTCON,GIE	;GIE=1     
			bsf		INTCON,PEIE	;PEIE=1          TIMER1
			bsf		INTCON,RAIE	;RAIE=1    PORTA
			
			bsf		ADCON0,ADON	;AD  
			bcf		ADCON0,VCFG	;   Vdd

			bcf		ADCON0,4	
			bcf		ADCON0,3
			bcf		ADCON0,2	;  000 - RA0

			bsf		ADCON0,ADFM	;   ADRESH<1:0>,ADRESL<7:0>

			bsf		STATUS,RP0	;  1     ADCON1
			bcf		ADCON1,6
			bcf		ADCON1,5
			bsf		ADCON1,4	;ADS2:ADS0	001	     Tosc/8 2 

			bsf		PIE1,ADIE	;   AD

;3.   

	;   	

			bcf		STATUS,RP0

			;     
			;0206
			movlw	0x02
			movwf	Srv_Nt_Min_H
			movlw	0x06
			movwf	Srv_Nt_Min_L
			;05BA
			movlw	0x05
			movwf	Srv_Nt_Max_H
			movlw	0xBA
			movwf	Srv_Nt_Max_L

			;      
			;0206
			movlw	0x02
			movwf	Srv_Min_H
			movlw	0x06
			movwf	Srv_Min_L
			;05BA
			movlw	0x05
			movwf	Srv_Max_H
			movlw	0xBA
			movwf	Srv_Max_L

			;         
			movlw	0x03
			movwf	Out_Corr_H
			movlw	0xDE
			movwf	Out_Corr_L

			;           
			movlw	0x01
			movwf	AD_Corr_H
			movlw	0xFF
			movwf	AD_Corr_L
			
			;       
			movlw	0x01
			movwf	AD_Nt_H
			movlw	0xFF
			movwf	AD_Nt_L

			;      
			;012D
			movlw	0x01
			movwf	AD_Min_H
			movlw	0x2D
			movwf	AD_Min_L
			;02D2
			movlw	0x02
			movwf	AD_Max_H
			movlw	0xD2
			movwf	AD_Max_L

			;    
			movlw	0x06
			movwf	Add_K

			;    
			;     
			movlw	.20
			movwf	Count_Srv_Nt

			;    AD_(H,L)
			bcf		STATUS,RP0	;  1    IOCA
		
			movlw	0x01
			movwf	AD_H

			movlw	0xFF
			movwf	AD_L

			;     
			bcf		STATUS,RP0	;  1    IOCA
		
			movlw	0x00
			movwf	Out_Add_H

			movlw	0x00
			movwf	Out_Add_L

			movlw	0x00
			movwf	Out_Add_CHL

			;         
			movlw	.255
			call	PAUSE_MLS

			movlw	.255
			call	PAUSE_MLS

			movlw	.255
			call	PAUSE_MLS

			movlw	.255
			call	PAUSE_MLS

			;   PORTA
			bsf		STATUS,RP0	;  1    IOCA
			bsf		IOCA,2		;   POTRA<2>

			;    TMR0      
			bsf		STATUS,RP0	;  1     INTCON
			bsf		INTCON,T0IE	;   TIMER0
loop
			NOP
			goto 	loop

;   TIMER0,       
Int_TMR0
			;    TMR0     
			bsf		STATUS,RP0	;  1     INTCON

			bcf		INTCON,T0IE	;   TIMER0
			bcf		INTCON,T0IF	;    TIMER0

			;     
			bcf		STATUS,RP0

			movlw	0x03
			movwf	In_H

			movlw	0xE5
			movwf	In_L

			;  0      ADCON0			
			bcf		STATUS,RP0	

			; 
			bsf		ADCON0,1	;GO/DANE=1 

			return
Int_PORTA
			;  
			bcf		STATUS,RP0	;  0     TMR0
			clrf	TMR0		;   TMR0

			;   PORTA
			bsf		STATUS,RP0	;  1      IOCA
			bcf		IOCA,2		;   RA2

			;  RA2	
			bcf		STATUS,RP0	;  0     PORTA
			btfsc	PORTA,2		;        
			goto	IN_01		;   
			goto    IN_10		;   

;    
IN_01
			;  0    TMR1L,TMR1H, T1CON		
			bcf		STATUS,RP0	

			;  0   TIMER1
			clrf	TMR1L		;  
			clrf	TMR1H		;  		

			; 
			bsf		T1CON,TMR1ON; 

			;  PORTA
			bsf		STATUS,RP0	;  1     IOCA
			bsf		IOCA,2		;   RA2

			goto	End_Int_PORTA
IN_10
			;  0    T1CON,
			bcf		STATUS,RP0	

			; 
			bcf		T1CON,TMR1ON; 

			;    In_H,In_L
			movfw	TMR1H		
			movwf	In_H

			movfw	TMR1L		
			movwf	In_L

			;  0      ADCON0			
			bcf		STATUS,RP0	

			;    
			bsf		ADCON0,1	;GO/DANE=1  

End_Int_PORTA
			bcf		STATUS,RP0	;  0     INTCON
			bcf		INTCON,RAIF	;    PORTA

			return			

;,         , 
;     ,     
Set_Srv_Nt
			bcf		STATUS,RP0
			
			;       
			movf	Count_Srv_Nt,1	;  Count_Srv_Nt  
			btfsc	STATUS,Z		; Z=0  Count_Srv_Nt>0   
			
			return			

			;          
			decfsz	Count_Srv_Nt,1	; Count_Srv_Nt=0   
			;        Srv_Nt_Min(HL)
			goto	Count_Srv_Nt_Else

			;      Srv_Nt_Min(H,L)  Srv_Nt_Max(H,L)
			movfw	Srv_Nt_Min_H
			movwf	Srv_Nt_Max_H

			movfw	Srv_Nt_Min_L
			movwf	Srv_Nt_Max_L

			;      Srv_Nt_Min(HL)-2  Srv_Nt_Max(HL)+2
			;Min
			movfw	Srv_Nt_Min_H
			movwf	H1

			movfw	Srv_Nt_Min_L
			movwf	L1

			movlw	0x00
			movwf	H2

			movlw	0x02
			movwf	L2

			call    Sub_To_Byte			

			bcf		STATUS,RP0

			movfw	H
			movwf	Srv_Nt_Min_H

			movfw	L
			movwf	Srv_Nt_Min_L

			;Max
			movfw	Srv_Nt_Max_H
			movwf	H1

			movfw	Srv_Nt_Max_L
			movwf	L1

			movlw	0x00
			movwf	H2

			movlw	0x02
			movwf	L2

			call    Add_To_Byte			

			bcf		STATUS,RP0

			movfw	H
			movwf	Srv_Nt_Max_H

			movfw	L
			movwf	Srv_Nt_Max_L

			return			

Count_Srv_Nt_Else
			;        Srv_Nt_Min(HL)
			movfw	In_H
			movwf	Srv_Nt_Min_H

			movfw	In_L
			movwf	Srv_Nt_Min_L

			return
Int_AD
			;  0      PIR1
			bcf		STATUS,RP0	

			;C   
			bcf		PIR1,ADIF	

			;     
			call	Set_Srv_Nt	;Srv_Nt_Min_(H,L):=In_(H,L)-X, Srv_Nt_Max_(H,L):=In_(H,L)+X

			call	Sav_AD		;AD_(H,L):=(ADRES(H,L)+AD_(H,L))/2
			call	Set_AD_Corr	;AD_Corr_(HL):=AD_(HL)
			call	Set_Last_Add;Last_Add_(H,L,CHL):=AD_Corr_(HL)-AD_Nt_(HL)
			call	Last_Add_K	;Last_Add_(H,L,CHL):=Last_Add_(H,L,CHL)*K_Add
			call	Add_Add_Out	;Out_Add_(H,L,CHL)=Out_Add_(H,L,CHL)+(Last_Add_(H,L,CHL)-Out_Add_(H,L,CHL))
			call	Set_Out		;Out_(H,L)=In_(H,L)+Out_Add_(H,L,CHL)
			call	Set_Out_Corr;Out_Corr_(HL):=Out_(HL)
			call	Out			;  

			return
Sav_AD
			;       AD_(H,L):=(ADRES(H,L)+AD_(H,L))/2
			;-   

			bcf		STATUS,RP0
			movfw	ADRESH

			bcf		STATUS,RP0
			movwf	H1

			bsf		STATUS,RP0
			movfw	ADRESL

			bcf		STATUS,RP0
			movwf	L1

			;-   
			bcf		STATUS,RP0

			movfw	AD_H
			movwf	H2
			movfw	AD_L
			movwf	L2

			;-     AD,   H,L
			call	Add_To_Byte			
			
			;-    ,  H,L   
			call	Right_To_Byte					

			;-   H->AD_H, L->AD_L
			bcf		STATUS,RP0

			movfw	H
			movwf	AD_H
			movfw	L
			movwf	AD_L

			return

;      H  L 
Right_To_Byte
			bcf		STATUS,RP0

			bcf		STATUS,0	; 
			rrf		L,1
			btfsc	H,0			;      1    
			bsf		L,7			;  1    
			bcf		STATUS,0	; 
			rrf		H,1

			return

Int_TIMER1
			;  0    T1CON, PIR1, PORTA
			bcf		STATUS,RP0	

			; 
			bcf		T1CON,TMR1ON

			;    TIMER1
			bcf		PIR1,TMR1IF	

			;    0
			bcf		PORTA,4		;RA4=0
			
			;  0     PIE1, IOCA
			bsf		STATUS,RP0	

			;   TIMER1
			bcf		PIE1,TMR1IE

			;   RA2
			bsf		IOCA,2		

			;   TIMER0     
			bsf		STATUS,RP0	;  1     INTCON
			bsf		INTCON,T0IE	;   TIMER0

			;    TIMER0,       20  
			bcf		STATUS,RP0	;  0     TMR0

			movlw	0xB0
			movwf	TMR0

			return

;    2    1
Add_To_Byte
			clrf	CL			;     
			movfw	L2
			addwf	L1,0
			movwf	L
			btfsc	STATUS,C	; =0,   
			incf	CL,1		;     

			clrf	CH
			movfw	H2			; 
			addwf	H1,0		;       W
			movwf	H			;      W  H
			btfsc	STATUS,C	; =0,   
			incf	CH,1		;     

			movfw	CL
			addwf	H,1			;       
			btfsc	STATUS,C	; =0,   
			incf	CH,1		;     
			clrf	CL			;     
			
			movfw	CH
			addwf	L,1			;       
			btfsc	STATUS,C	; =0,   
			incf	CL,1		;     
			clrf	CH			;     

			movfw	CL
			addwf	H,1			;     
			clrf	CL			;     

			clrf	CHL			;CHL=0	 
			return

;    2    1
Sub_To_Byte
			clrf	CL			;     
			comf	L2,0		;L2  ->W
			addwf	L1,0		;W+L1
			movwf	L			;   ->L
			btfsc	STATUS,C	; =0,   
			incf	CL,1		;     

			clrf	CH			;     
			comf	H2,0		;H2  ->W
			addwf	H1,0		;       W
			movwf	H			;      W  H
			btfsc	STATUS,C	; =0,   
			incf	CH,1		;     

			;6.      
			movfw	CL			;CL->W
			addwf	H,1			;       
			btfsc	STATUS,C	; =0,   
			incf	CH,1		;     
			clrf	CL			;     
			
			;7.      
			movfw	CH			;CH->W
			addwf	L,1			;       
			btfsc	STATUS,C	; =0,   
			incf	CL,1		;     
			clrf	CH			;     

			;8.      
			movfw	CL			;CL->W
			addwf	H,1			;     
			clrf	CL			;     

			;   1  2	
			call 	Comp_To_Byte;W=0 1=2,W=1 1>2,W=2,1<2

			bcf		STATUS,RP0	;  0     CHL

			movwf	CHL			;    CHL
			btfsc	CHL,0		;  CHL<0>
			goto	CHL_0		;CHL<0>=1 1>2  

			btfsc	CHL,1		; CHL<1>
			goto	CHL_1		;CHL<1>=1 1<2  

			comf	H,1
			comf	L,1

			goto	CHL_0		;CHL<0>=0  CHL<1>=0 1=2  			

CHL_0
			clrf	CHL			; CHL=0
			return

CHL_1	
			; 
			comf	H,1
			comf	L,1
			
			movlw	b'00000001'

			movwf	CHL

			return
;   :  1 = 2 W='00000000'
;										    1 > 2 W='00000001'
;										    1 < 2 W='00000010'
Comp_To_Byte

CompH
			;-    H1  H2
			bcf		STATUS,RP0

			movfw	H1		;H1->W
			subwf	H2,0 	;H2(f)-H1(W)->W

			btfss	STATUS,C	; C=0   .. H2<H1,   
			retlw	b'00000001'	; :Comp1 
			
			;H1<H2  H1=H2
			btfss	STATUS,Z	; Z=1  H1=H2 -  ,     ,   
			retlw	b'00000010'	;Z=0    ,   H1<H2

CompL		
			;-       
			movfw	L1
			subwf	L2,0 	;L2(f)-L1(W)->W

			btfss	STATUS,C	; C=0   .. L2<L1,   
			retlw	b'00000001'	; :Comp1 
			
			;L1<L2  L1=L2
			btfss	STATUS,Z	; Z=1  L1=L2 -      ,   
			retlw	b'00000010'	;Z=0    ,   H1<H2
			retlw	b'00000000'

;      Out_Corr_(HL)
Out
			bcf		STATUS,RP0	;  0     Out_Corr_H, TMR1H, Out_Corr_L, TMR1L, T1CON, PORTA 

			;   
			comf	Out_Corr_H,0
			movwf	TMR1H

			comf	Out_Corr_L,0
			movwf	TMR1L
			
			;    1
			bsf		PORTA,4	

			; 
			bsf		T1CON,TMR1ON

			;  1     PIE1 			
			bsf		STATUS,RP0	

			;   TIMER1
			bsf		PIE1,TMR1IE	;   TIMER1

			return
;      
Set_Out_Corr
			bcf		STATUS,RP0

			;   Out_(HL)   Srv_Min_(HL)
			movfw	Out_H
			movwf	H1

			movfw	Out_L
			movwf	L1

			movfw	Srv_Min_H
			movwf	H2

			movfw	Srv_Min_L
			movwf	L2

			call	Comp_To_Byte

			;     Out_(HL)   Srv_Min_(HL)
			bcf		STATUS,RP0	;  0     CHL
			movwf	CHL			;    CHL

			btfsc	CHL,1		;  CHL<1>
			goto	Corr_Min	;Out_(HL)<Srv_Min_(HL)

			;   Out_(HL)   Srv_Max_(HL)
			movfw	Out_H
			movwf	H1

			movfw	Out_L
			movwf	L1

			movfw	Srv_Max_H
			movwf	H2

			movfw	Srv_Max_L
			movwf	L2

			call	Comp_To_Byte

			;     Out_(HL)   Srv_Max_(HL)
			bcf		STATUS,RP0	;  0     CHL
			movwf	CHL			;    CHL

			btfsc	CHL,0		;  CHL<0>
			goto	Corr_Max	;Out_(HL)>Srv_Max_(HL)

			; Out_(HL)   
			movfw   Out_H
			movwf	Out_Corr_H

			movfw   Out_L
			movwf	Out_Corr_L

			return
Corr_Min
			movfw   Srv_Min_H
			movwf	Out_Corr_H

			movfw   Srv_Min_L
			movwf	Out_Corr_L

			return

Corr_Max
			movfw   Srv_Max_H
			movwf	Out_Corr_H

			movfw   Srv_Max_L
			movwf	Out_Corr_L

			return

;      , W=0 - , W=1 - 
Is_In_Nt
			; In_(HL)  Srv_Nt_Min(HL)
			bcf		STATUS,RP0

			movfw	In_H
			movwf	H1			

			movfw	In_L
			movwf	L1		

			movfw	Srv_Nt_Min_H
			movwf	H2			

			movfw	Srv_Nt_Min_L
			movwf	L2		

			call	Comp_To_Byte

			bcf		STATUS,RP0

			movwf	CHL
			btfsc	CHL,1	; CHL<1>=1,  In_(HL)<Srv_Nt_Min_(HL),     
			retlw	.0		;   	

			; In_(HL)  Srv_Nt_Max(HL)
			bcf		STATUS,RP0

			movfw	In_H
			movwf	H1			

			movfw	In_L
			movwf	L1		

			movfw	Srv_Nt_Max_H
			movwf	H2			

			movfw	Srv_Nt_Max_L
			movwf	L2		

			call	Comp_To_Byte

			bcf		STATUS,RP0

			movwf	CHL
			btfsc	CHL,0	; CHL<0>=1,  In_(HL)>Srv_Nt_Max_(HL),     
			retlw	.0		;   	

			retlw	.1		;  

;     In_(HL) 
;   Out_Add_(HL)     Out_Add_CHL
;Out_(H,L)=In_(H,L)+Out_Add_(H,L,CHL)
Set_Out
			bcf		STATUS,RP0

			;     , W=0 - , W=1 - 
			call	Is_In_Nt
			
			;     W 0
			addlw	.0
			btfss	STATUS,Z		; Z=1      
									;  
			goto	In_Is_Nt	;Z=0     

			;  ,   In_(HL)->Out_(HL)  
			movfw	In_H
			movwf	Out_H

			movfw	In_L
			movwf	Out_L

			movlw	.0			
			movwf	Out_CHL		;    

			return

;  ,    
In_Is_Nt
			movfw	In_H
			movwf	H1

			movfw	In_L
			movwf	L1

			movfw	Out_Add_H
			movwf	H2

			movfw	Out_Add_L
			movwf	L2

			btfsc	Out_Add_CHL,0	;       
			goto 	In_Add_Add	;Out_Add_CHL<0>=1
			goto 	In_Sub_Add	;Out_Add_CHL<0>=0

In_Sub_Add
			call	Sub_To_Byte	;Out_Add_CHL<0>=1
			goto	Save_Out
In_Add_Add
			call	Add_To_Byte	;Out_Add_CHL<0>=0
			goto	Save_Out
Save_Out
			bcf		STATUS,RP0

			movfw   H
			movwf	Out_H

			movfw   L
			movwf	Out_L

			movfw	CHL
			movwf	Out_CHL		; 

			return

;        
;Last_ADD_(H,L):=AD_Corr_(HL)-AD_Nt_(HL),Last_ADD_(HL):=CHL
Set_Last_Add
			bcf		STATUS,RP0

			movfw	AD_Corr_H
			movwf	H1

			movfw	AD_Corr_L
			movwf	L1

			movfw	AD_Nt_H
			movwf	H2

			movfw	AD_Nt_L
			movwf	L2

			call 	Sub_To_Byte

			;-c          
			bcf		STATUS,RP0

			movfw	H
			movwf	Last_Add_H

			movfw	L
			movwf	Last_Add_L

			movfw	CHL
			movwf	Last_Add_CHL

			return

;    
Add_Add_Out
			;-   Out_Add_(H,L,CHL)=Out_Add_(H,L,CHL)+(Last_Add_(H,L,CHL)-Out_Add_(H,L,CHL))
			bcf		STATUS,RP0

			movfw	Last_Add_H
			movwf	H1
			
			movfw	Last_Add_L
			movwf	L1

			movfw	Out_Add_H
			movwf	H2
			
			movfw	Out_Add_L
			movwf	L2

			;-      Last_Add_CHL  Out_Add_CHL
			movfw	Last_Add_CHL
			subwf	Out_Add_CHL,0	;W:=Out_Add_CHL-Last_Add_CHL
			btfsc	STATUS,Z		; Z=0   ,    ,  			
			goto 	Sub_Add
			goto	Add_Add

Sub_Add
			call	Sub_To_Byte			
			goto	Znak		

Add_Add
			call	Add_To_Byte			
			goto	Znak		

Znak
			;-    Last_Add_CHL  Out_Add_CHL   Last_Add_CHL
			btfss	Last_Add_CHL,0	; 1   
			goto	Not_Invert_CHL	
			;- Last_Add_CHL<0>=1,  Last_Add_HL<0,    	CHL
			comf	CHL,0			;   W:=NOT(CHL)
			andlw	b'00000001'
			movwf	CHL
			
Not_Invert_CHL
			;-    
			movlw	0x00

			btfsc	L,0
			movlw	0x00
			btfsc	L,1
			movlw	0x00
			btfsc	L,2
			movlw	0x01
			btfsc	L,3
			movlw	0x01
			btfsc	L,4
			movlw	0x02
			btfsc	L,5
			movlw	0x02
			btfsc	L,6
			movlw	0x03
			btfsc	L,7
			movlw	0x03

			btfsc	H,0
			movlw	0x04
			btfsc	H,1
			movlw	0x04
			btfsc	H,2
			movlw	0x05
			btfsc	H,3
			movlw	0x05
			btfsc	H,4
			movlw	0x06
			btfsc	H,5
			movlw	0x06
			btfsc	H,6
			movlw	0x07
			btfsc	H,7
			movlw	0x07

			;-     
			bcf		STATUS,RP0
			movwf	Right_Count

Right_Else			
			movf	Right_Count,1	;   0
			btfsc	STATUS,2		; Z=0  Right_Count>0,   
			goto	Right_End			

			call 	Right_To_Byte
			bcf		STATUS,RP0
			decfsz	Right_Count,1	; Z=1    ,   
			goto	Right_Else

Right_End
			;-    Out_Add_(HL)
			movfw	Out_Add_H
			movwf	H1
			
			movfw	Out_Add_L
			movwf	L1

			movfw	H
			movwf	H2
			
			movfw	L
			movwf	L2

			;-      CHL  Out_Add_CHL
			movfw	CHL
			subwf	Out_Add_CHL,0	;W:=Out_Add_CHL-CHL
			btfsc	STATUS,Z		; Z=0   ,    ,  			
			goto	Add_Out
			goto	Sub_Out

Sub_Out
			call	Sub_To_Byte			
			goto	Znak_Out

Add_Out
			call	Add_To_Byte			
			goto	Znak_Out
			
Znak_Out
			;-       Last_Add_CHL
			btfss	CHL,0			; 1   
			goto	Sav_Out_Add	
			;- CHL<0>=1,  HL<0,    	CHL
			comf	Out_Add_CHL,0	;   W:=NOT(Out_Add_CHL)
			andlw	b'00000001'
			movwf	Out_Add_CHL

Sav_Out_Add
			;-    Out_Add_(H,L,CHL)
			movfw	H
			movwf	Out_Add_H

			movfw	L
			movwf	Out_Add_L

			return

;        K_Add
Last_Add_K
			bcf		STATUS,RP0

			;Add_K->Count_K
			movfw	Add_K
			movwf	Count_K

			;      
			movfw	Last_Add_H
			movwf	H

			movfw	Last_Add_L
			movwf	L
Check_Else
			decfsz	Count_K,1
			goto	Add_Else	;    Add_K=0
			goto	End_K		;Add_K=0      Last_Add_(HL)
Add_Else
			movfw	H
			movwf	H1

			movfw	L
			movwf	L1

			movfw	Last_Add_H
			movwf	H2

			movfw	Last_Add_L
			movwf	L2

			call	Add_To_Byte	

			goto	Check_Else
End_K
			bcf		STATUS,RP0

			movfw	H
			movwf	Last_Add_H

			movfw	L
			movwf	Last_Add_L
			
			return

;      
Set_AD_Corr
			bcf		STATUS,RP0
			
			movfw	AD_H
			movwf	AD_Corr_H			

			movfw	AD_L
			movwf	AD_Corr_L

			return

;   1  256  (   W)
PAUSE_MLS
			movwf	MLS_NUM		;      MLS_NUM
MLS_NUM_DEC
			call	MLS			;   1 
			decfsz	MLS_NUM	,1	; MLS_NUM  1
			goto	MLS_NUM_DEC	

			RETURN

;   1 
MLS
			bcf		STATUS,0	;  0     MKS			
			movlw	.217	;  W      1 
			movwf	MLS_CNT		;    
MLS_CNT_DEC	
			decfsz	MLS_CNT,1	;    1
			goto 	MLS_CNT_DEC	;       0
			
			RETURN

;   10  1000  (   W)
PAUSE_MKS
			movwf	MKS_NUM		;      MKS_NUM
MKS_NUM_DEC
			call	MKS			;   10 
			decfsz	MKS_NUM,1	; MKS_NUM  1
			goto	MKS_NUM_DEC	

			RETURN

;   10 
MKS
			RETURN			
		
			ORG		0x03FF
			RETLW 	0
			
			ORG		0x2100
			DE		0x00,0x01,0x02,0x03
	
			END
